function varargout = newtonRaphsonGui(varargin)
% NEWTONRAPHSONGUI MATLAB code for newtonRaphsonGui.fig
%      NEWTONRAPHSONGUI, by itself, creates a new NEWTONRAPHSONGUI or raises the existing
%      singleton*.
%
%      H = NEWTONRAPHSONGUI returns the handle to a new NEWTONRAPHSONGUI or the handle to
%      the existing singleton*.
%
%      NEWTONRAPHSONGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in NEWTONRAPHSONGUI.M with the given input arguments.
%
%      NEWTONRAPHSONGUI('Property','Value',...) creates a new NEWTONRAPHSONGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before newtonRaphsonGui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to newtonRaphsonGui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help newtonRaphsonGui

% Last Modified by GUIDE v2.5 17-Jun-2016 12:18:53

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @newtonRaphsonGui_OpeningFcn, ...
                   'gui_OutputFcn',  @newtonRaphsonGui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

function newtonRaphsonGui_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;

global gui
gui.plotColor = 'k';
set(handles.text_step,'String','Steps: ');
set(handles.text_result,'String','z =     ');
set(handles.toggle_image,'String','Show Image');

guidata(hObject, handles);

function varargout = newtonRaphsonGui_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;

function edit_start_x_Callback(hObject, eventdata, handles)
global gui
gui.startX = str2num(get(hObject,'String'));

try
    delete(findobj(handles.axes1,'Tag','StartPoint'));
    delete(findobj(handles.axes1,'Tag','EndPoint'));
    delete(findobj(handles.axes1,'Tag','Steps'));
catch
end
hold on
plot(handles.axes1,gui.startX*1000,gui.startY*1000,'o','MarkerEdgeColor',gui.plotColor,'MarkerFaceColor',gui.plotColor,'LineWidth',5,'Tag','StartPoint');
% axis([-1500 1500 -1500 1500]);
grid on

function edit_start_x_CreateFcn(hObject, eventdata, handles)
set(hObject,'String','0.0');
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_start_y_Callback(hObject, eventdata, handles)
global gui
gui.startY = str2num(get(hObject,'String'));

try
    delete(findobj(handles.axes1,'Tag','StartPoint'));
    delete(findobj(handles.axes1,'Tag','EndPoint'));
    delete(findobj(handles.axes1,'Tag','Steps'));
catch
end
hold on
plot(handles.axes1,gui.startX*1000,gui.startY*1000,'o','MarkerEdgeColor',gui.plotColor,'MarkerFaceColor',gui.plotColor,'LineWidth',5,'Tag','StartPoint');
% axis([-1500 1500 -1500 1500]);
grid on

function edit_start_y_CreateFcn(hObject, eventdata, handles)
set(hObject,'String','0.0');
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function axes1_ButtonDownFcn(hObject, eventdata, handles)
global gui

set(handles.text_step,'String','Steps: ');
set(handles.text_result,'String','z =     ')

try
    delete(findobj(handles.axes1,'Tag','StartPoint'));
    delete(findobj(handles.axes1,'Tag','EndPoint'));
    delete(findobj(handles.axes1,'Tag','Steps'));
    
    delete(findobj(handles.axes1,'Type','Line'));
catch
end

a = get(handles.axes1,'CurrentPoint');

gui.startX = round(a(1,1))/1000;
gui.startY = round(a(1,2))/1000;

set(handles.edit_start_x,'String',num2str(gui.startX));
set(handles.edit_start_y,'String',num2str(gui.startY));

hold on
plot(handles.axes1,a(1,1),a(1,2),'Marker','+','Markersize',10,'MarkerEdgeColor',gui.plotColor,'MarkerFaceColor',gui.plotColor,'LineWidth',10,'Tag','StartPoint');
% axis([-1500 1500 -1500 1500]);
grid on

function button_start_Callback(hObject, eventdata, handles)
global gui

set(hObject,'Enable','off');
drawnow;

syms x
f(x) = x^4 - 1;
df(x) = diff(f,x);
f = matlabFunction(f);
df = matlabFunction(df);

% settings
tol = eps; % tolerance, e.g. reqired accuracy
maxStep = 2e2; % allowed steps

x0 = gui.startX + gui.startY*1i;

[xn,step,Xtraj] = subNewtonRaphsonIteration(x0, f, df, tol, maxStep, handles);


% set(handles.text_x,'String',(num2str(real(xn))));
% set(handles.text_y,'String',(num2str(imag(xn))));

set(handles.text_step,'String',['Steps: ',num2str(step)]);
if imag(xn) > 0; sig = ' + '; else sig = ' - '; end
set(handles.text_result,'String',['z = ',num2str(real(xn)),sig,num2str(abs(imag(xn))),'i'])

hold on
plot(handles.axes1,real(xn)*1000,imag(xn)*1000,'o','MarkerEdgeColor',gui.plotColor,'MarkerFaceColor',gui.plotColor,'LineWidth',3,'Tag','EndPoint');

set(hObject,'Enable','on');

function button_close_Callback(hObject, eventdata, handles)
close('newtonRaphsonGui');

function showHideImage(handles,show_)
global gui
if show_
    gui.plotColor = 'w';
    axes(handles.axes1);
    Bild = imread('fractal_4z-1','bmp'); 
    h_im = imagesc(Bild);
    set(h_im,'XData',[-1500 1500])
    set(h_im,'YData',[-1500 1500])
    axis([-1500 1500 -1500 1500]);
    set(h_im,'ButtonDownFcn',{@axes1_ButtonDownFcn,handles});   
    set(findobj(handles.axes1,'Type','image'), 'ButtonDownFcn',{@axes1_ButtonDownFcn,handles});   
    set(handles.axes1,'XTickLabel',[-1.5; -1.0; -0.5; 0.0; 0.5; 1.0; 1.5]);
    set(handles.axes1,'YTickLabel',[-1.5; -1.0; -0.5; 0.0; 0.5; 1.0; 1.5]);
    set(handles.axes1,'YDir','normal');
    set(handles.toggle_image,'BackgroundColor',[0.8 0.84 0.88])
    set(handles.toggle_image,'String','Hide Image');
else
    gui.plotColor = 'k';
    im = findobj(handles.axes1,'Type', 'image');
    delete(im);
    drawnow;
    set(handles.axes1,'ButtonDownFcn',{@axes1_ButtonDownFcn,handles});
    grid on
    set(handles.toggle_image,'BackgroundColor',[0.97 0.98 0.99]);
    set(handles.toggle_image,'String','Show Image');
end

function [xn,step,Xtraj] = subNewtonRaphsonIteration(x0,f,df,tol,maxStep,handles)
global gui
step = 0;  % iteration steps
xn = x0;
Xtraj = xn;

err = abs(xn);
while err > tol
        xn1 = xn - f(xn)/df(xn);
        err = abs(xn - xn1);
        step = step + 1;
        xn = xn1;
        Xtraj(end+1) = xn;
        pause(0.15);
        hold on
        plot(handles.axes1,1000*[real(Xtraj(end-1)),real(Xtraj(end))],1000*[imag(Xtraj(end-1)),imag(Xtraj(end))],'-*','Color',gui.plotColor,'LineWidth',2);
        drawnow;
        if step > maxStep; break; end
end
        
function axes1_CreateFcn(hObject, eventdata, handles)
% axes(hObject);    
axis([-1500 1500 -1500 1500]);
set(hObject,'XTickLabel',[-1.5; -1.0; -0.5; 0.0; 0.5; 1.0; 1.5])
set(hObject,'YTickLabel',[-1.5; -1.0; -0.5; 0.0; 0.5; 1.0; 1.5])
grid on;
set(hObject,'YDir','normal');

% title('f(z) = z^4 -1');
% xlabel('Real Axis');
% ylabel('Imaginary Axis');
% 
% xlab_ = get(hObject,'XLabel');
% ylab_ = get(hObject,'YLabel');
% set(xlab_,'String','Real Axis');
% set(ylab_,'String','Imaginary Axis');

function toggle_image_Callback(hObject, eventdata, handles)
showHideImage(handles,logical(get(hObject,'Value')));

function newtonRaphson_ResizeFcn(hObject, eventdata, handles)

set(hObject,'Units','centimeters');
FigurePos = get(hObject,'Position');

% Axes
AxesPos = get(handles.axes1,'Position');
AxesPos(3) = FigurePos(3) - 6.5;
AxesPos(4) = FigurePos(4) - 2;
set(handles.axes1,'Position',AxesPos);

TitelPos = get(handles.text_titel,'Position');
TitelPos(2) = AxesPos(2) + AxesPos(4) + 0.2;
TitelPos(3) = AxesPos(3);
set(handles.text_titel,'Position',TitelPos);
