function [xn,step,Xtraj] = newtonRaphsonIteration(x0,f,df,tol,maxStep)
%% Newton-Raphson-Iteration
% Numerische Methoden der Dynamik - SS19
% Dr.-Ing. Pascal Ziegler
%
% Institut f�r Tecnische und Numerische Mechanik
% Prof. Dr.-Ing. Prof. E.h. P. Eberhard
%
% Autor: Andreas Hofmann, M.Sc.
%

        step = 0;  % iteration steps
        xn = x0;
        Xtraj = xn;
        
        err = abs(xn);
        while err > tol
                xn1 = xn - f(xn)/df(xn);
                err = abs(xn - xn1);
                step = step + 1;
                xn = xn1;
                Xtraj(end+1) = xn;
                if step > maxStep; break; end
        end
        
end
        