%% Rundungsfehler beim Programmieren
% Erstellt mit Matlab R2014b, Debian GNU/Linux 7
% Keine Gewaehr, dass dieses Problem mit anderen Matlab-Versionen oder auf anderen
% Systemen reproduzierbar ist.
%
% Numerische Methoden der Dynamik - SS19
% Dr.-Ing. Pascal Ziegler
%
% Institut fuer Technische und Numerische Mechanik
% Prof. Dr.-Ing. Prof. E.h. P. Eberhard
%
% Autor: Andreas Hofmann, M.Sc.
%

clear all
close all

h = 0.1;   % Schrittweite
t0 = 0;     % Startwert
t1 = 1;   % Endwert

% for Schleife
timeVec1 = 0:h:t1;
for index = 1:length(timeVec1)
    t = timeVec1(index)
end

% while Schleife
t = t0;
timeVec2 = t
while t < t1
    t = t+h
    timeVec2(end+1) = t;
end
% Vergleiche timeVec1 mit timeVec2
% Was ist der Unterschied? Wo liegt der Fehler?
Aussage = timeVec2(end-1) <  t1  % Aussage der Form 0.1 < 0.1 Warum ist die Aussage wahr?
Fehler = (t1 - timeVec2(end-1))/h % relativer Fehler!
Maschinengenauigkeit = eps % Maschinengenauigkeit.

% Loesung um diesen Fehler zu vermeiden
tol = 1e-14; % Toleranz einf�hren
t = t0;
timeVec3 = t
while t < t1-tol % Toleranz in der Schranke beruecksichtigen
    t = t+h
    timeVec3(end+1) = t;
end
% Grundsaetzlich: Achtung bei while Schleifen bzw. Abfragen von rekursiv errechneten Werten!

% Zusaetzlich: Was passiert, wenn man die Schrittweite h variiert?


